local hold_colors= {
	TapNoteSubType_Hold= {1, 1, 0, 1},
	TapNoteSubType_Roll= {1, 0, 1, 1},
}
local white= {1, 1, 1, 1}

return function(button_list)
	local rots= {
		Left= 90,
		Down= 0,
		Up= 180,
		Right= -90,
		UpLeft= 135,
		UpRight= -135,
		DownLeft= 45,
		DownRight= -45,
	}
	local ret= {}
	local warning_time= 1
	local red= {1, 0, 0, 1}
	local white= {1, 1, 1, 1}
	for i, button in ipairs(button_list) do
		ret[i]= Def.ActorFrame{
			InitCommand= function(self)
				self:draworder(newfield_draw_order.explosion)
			end,
			WidthSetCommand= function(self, param)
				param.column:set_layer_fade_type(self, "FieldLayerFadeType_Explosion")
			end,
			Def.Sprite{
				Texture= "tap_explosion", InitCommand= function(self)
					self:rotationz(rots[button]):diffusealpha(0)
				end,
				ColumnJudgmentCommand= function(self, param)
					local diffuse= {
						TapNoteScore_W5= {0.8, 0.0, 0.6, 1},
						TapNoteScore_W4= {0.3, 0.8, 1.0, 1},
						TapNoteScore_W3= {0.0, 1.0, 0.4, 1},
						TapNoteScore_W2= {1.0, 1.0, 0.3, 1},
						TapNoteScore_W1= {1.0, 1.0, 1.0, 1},
						HoldNoteScore_Held= {1.0, 1.0, 0.0, 1},
					}
					local exp_color= diffuse[param.tap_note_score or param.hold_note_score]
					if param.bright then
						self:setstate(1)
					else
						self:setstate(0)
					end
					if exp_color then
						self:stoptweening()
							:diffuse(exp_color):zoom(1):linear(.06):zoom(1.1):linear(.06)
							:diffusealpha(0)
					end
				end,
			},
			Def.Sprite{
				Texture= "hold_explosion", InitCommand= function(self)
					self:diffusealpha(0)
				end,
				HoldCommand= function(self, param)
					if hold_colors[param.type] then
						if param.start then
							self:finishtweening()
								:zoom(1.1):diffuse(white)
								:diffuseblink():effectcolor1(hold_colors[param.type])
								:effectcolor2(white):effectperiod(.1)
						elseif param.finished then
							self:stopeffect():linear(0.06):diffusealpha(0)
								:sleep(0)
						else
							self:zoom(param.life * 1.1)
						end
					end
				end,
			},
		}
	end
	return ret
end
