return function(button_list)
	local rots= {
		Left= 90,
		Down= 0,
		Up= 180,
		Right= -90,
		UpLeft= 135,
		UpRight= -135,
		DownLeft= 45,
		DownRight= -45,
	}
	local hold_len= {
		start_note_offset= 0, end_note_offset= 12/64,
		head_pixs= 0, body_pixs= 64, tail_pixs= 12,
	}
	local function hold(state, tex)
		return {
			state_map= {parts_per_beat= 1, quanta= {{per_beat= 1, states= {state}}}},
			textures= {tex},
			flip= "TexCoordFlipMode_None",
			length_data= hold_len,
		}
	end
	local holds= {
		TapNoteSubType_Hold= {
			hold(2, "hold_body"),
			hold(1, "hold_body"),
		},
		TapNoteSubType_Roll= {
			hold(2, "roll_body"),
			hold(1, "roll_body"),
		},
	}
	local tap_states= NewSkin.generic_state_map(8, {1, 2, 3, 4, 6, 8, 12, 16})
	local columns= {}
	for i, button in ipairs(button_list) do
		columns[i]= {
			width= 64, padding= 0,
			anim_time= 4, anim_uses_beats= true,
			taps= {
				NewSkinTapPart_Tap= {
					state_map= tap_states,
					actor= Def.Sprite{
						Texture= "_down tap note", InitCommand= function(self)
							self:rotationz(rots[button]) end}},
				NewSkinTapPart_Mine= {
					state_map= tap_states,
					actor= Def.Sprite{
						Texture= "_down tap note", InitCommand= function(self)
							self:rotationz(rots[button]):diffuse{1,0,0,1} end}},
				NewSkinTapPart_Lift= {
					state_map= tap_states,
					actor= Def.Sprite{
						Texture= "_down tap note", InitCommand= function(self)
							self:rotationz(rots[button]+180) end}},
			},
			holds= holds,
			reverse_holds= holds,
		}
	end
	return {columns= columns}
end
