return function(button_list)
	local rots= {
		Left= 90,
		Down= 0,
		Up= 180,
		Right= -90,
		UpLeft= 135,
		UpRight= -135,
		DownLeft= 45,
		DownRight= -45,
	}
	local ret= {}
	local warning_time= 1
	local red= {1, 0, 0, 1}
	local white= {1, 1, 1, 1}
	for i, button in ipairs(button_list) do
		ret[i]= Def.Sprite{
			Texture= "Down Go Receptor", InitCommand= function(self)
				self:rotationz(rots[button]):draworder(newfield_draw_order.receptor)
			end,
			WidthSetCommand= function(self, param)
				param.column:set_layer_fade_type(self, "FieldLayerFadeType_Receptor")
			end,
			BeatUpdateCommand= function(self, param)
				if warning_time > 0 and param.second_distance < warning_time then
					self:diffuse(lerp_color(param.second_distance/warning_time, white, red))
				else
					self:diffuse(white)
				end
				if param.pressed then
					self:zoom(.75)
				elseif param.lifted then
					self:zoom(1)
				end
			end,
		}
	end
	return ret
end
